package djmil.cordacheckers.cordaclient;

import static org.assertj.core.api.Assertions.assertThat;

import java.util.List;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import djmil.cordacheckers.cordaclient.dao.GameState;
import djmil.cordacheckers.cordaclient.dao.Stone;
import djmil.cordacheckers.cordaclient.dao.Rank;
import djmil.cordacheckers.user.HoldingIdentityResolver;

@SpringBootTest
public class RankingTests {
    @Autowired
    CordaClient cordaClient;

    @Autowired
    HoldingIdentityResolver holdingIdentityResolver;

    @Test
    void testGlobalRanking() {
        final var hiCustodian  = holdingIdentityResolver.getCustodian();
        assertThat(hiCustodian).isNotNull();

        final List<Rank> liderboard1 = cordaClient.fetchRanking(hiCustodian);

        final var hiWinner = holdingIdentityResolver.getByUsername("Charlie");
        final var hiLooser = holdingIdentityResolver.getByUsername("Bob");

        final GameState game = cordaClient.gameProposalCreate(
            hiWinner, hiLooser, Stone.Color.WHITE, "GameBoard GLOBAL_RANKING test");

        cordaClient.gameProposalAccept(hiLooser, game.uuid());
        cordaClient.gameBoardSurrender(hiLooser, game.uuid());

        final List<Rank> liderboard2 = cordaClient.fetchRanking(hiCustodian);

        System.out.println(liderboard1);
        System.out.println(liderboard2);
    }

    @Test
    void testIndividualRanking() {
        final var hiCustodian  = holdingIdentityResolver.getByUsername("Bob");
        final List<Rank> liderboard = cordaClient.fetchRanking(hiCustodian);
        System.out.println(liderboard);
    }

}
